c PATCHY_MATNUM.f (mayo 2006)
c calcula una distribucion de valores 1 o 2 en
c forma de patches usando fn. de autocov. de Von Karman
c (adaptacion del programa  patchy_wc.f)
       include 'com_frac_wc'
       double precision t0,timer,ran1
       integer i,j,k,j1,k1,nreg,nn0,nn
       double precision x_min,x_max,z_min,z_max

       open(unit=9, file='matnum_patchy.dat', status='unknown')
       open(unit=11, file='matnum_patchy_gnu.dat', status='unknown')
       open(unit=20, file='matnum_patchy_coarse.dat', status='unknown')
       open(unit=30, file='slice_matnum_patchy.dat', status='unknown')
       open(unit=40, file='matnum_patchy_mud', status='unknown')       
       open(unit=50, file='matnum_patchy_utsira', status='unknown')
c         t0=timer()

150    format(e20.8)
170    format(i5)

      read(5,170)nreg

       nn0=0
       do i=1,nreg
       read(5,150)x_min
       read(5,150)x_max
       read(5,170)nn
       do j=nn0+1,nn0+nn+1
        x(j) = x_min + (x_max - x_min)*(j-nn0-1)/nn
       enddo
       nx = nn0+nn
       nn0 = nn+nn0
       enddo

      read(5,170)nreg

       nn0=0
       do i=1,nreg
       read(5,150)z_min
       read(5,150)z_max
       read(5,170)nn
       do k=nn0+1,nn0+nn+1
        z(k) = z_min + (z_max - z_min)*(k-nn0-1)/nn
       enddo
       nz = nn0+nn
       nn0 = nn+nn0
       enddo

       write(6,221)nx,nz
221    format(/,'nx   =  ',i5,/,
     1          'nz   =  ',i5,/)


c
c  Lectura de datos para generar el campo fractal  K_s 
c

        read(5,150)sig2_ks
        read(5,150)d_ks
        read(5,150)aa
        read(5,170)neg	
        read(5,150)threshold
c        read(5,150)sw_min
c        read(5,150)sw_max	    

        
c         write(6,171)sig2_ks,d_ks,sat_mean,delta_min,delta_max,aa,neg
         write(6,171)sig2_ks,d_ks,aa,neg,threshold 
171       format(/,' sig2_ks  = ',e12.5,/
     1            ,' d_ks     = ',e12.5,/
     1             ' aa= corr. length = ',e12.5,/
     1             ' neg = ',i5,/
     1             ' threshold = ',e12.5)
 

         neg1 = neg
         write(6,*)'-----------------------'

         write(6,*)'entra a fractal_coef'

         call fractal_coef
c  reads file ks.out 

c       write(6,23)timer()
23     format(/1x,'tiempo=',g20.8)
       stop
       end
*******************************************************************
        subroutine fractal_coef
       include 'com_frac_wc'
        integer j,k
        double precision cf(mnx,mnz),phi_w(mnx,mnz)
        double precision aver,var,ratio,max,min
 

        phi_min=1.d0
        phi_max=2.d0
c        threshold = 0.4187d0 
c        threshold = 0.56! this value gives 16 % gas saturation  for neg = -155

c        threshold = 0.575d0  ! this gives 6.85 percent gas saturation  for neg= -155
c        threshold = 0.49!   gives 52 % gas for neg= -155
c         threshold = 0.568d0 ! gives 8.33 % CO2 saturation 
c         threshold = 0.577d0 
        phi_mean=(phi_max+phi_min)*threshold ! this value gives 8.3 % CO2 sat for neg= -155

        phi_mean=(phi_max+phi_min)*threshold  ! this value gives 50. % CO2 sat for neg= -155

c         write(6,*)'dentro de fractal_coef'

          write(6,67)phi_max,phi_min,phi_mean
67       format(' phi_max = ',e12.5,/
     1          ' phi_min = ',e12.5,/
     1          ' phi_mean = ',e12.5/)
c
c       Calculo de la variacion  fractal  en cf
c

       call fractal(sig2_ks,d_ks,phi_mean,cf) 
c de esta rutina sale la matriz cf con media cero y varia entre [-1,1]
c Normalizamos cf al intervalo (phi_min,phi_max)
         do j=1,nx
         do k=1,nz
         cf(j,k)=0.5d0*cf(j,k)*(phi_max-phi_min)+
     #           0.5d0*(phi_min+phi_max)
          enddo
	  enddo
          max = cf(1,1)
          min = cf(1,1)
          do j=1,nx
          do k=1,nz
          if(cf(j,k).gt.max) max = cf(j,k)
          if(cf(j,k).lt.min) min = cf(j,k)
          enddo
 	  enddo
          write(6,68) max,min
68       format(' cf max = ',e12.5,
     1          ' cf min = ',e12.5)


         do j=1,nx
         do k=1,nz
         phi_w(j,k)=cf(j,k)
c         write(10,99)cf(j,k)
         enddo
	 enddo

c Patches de valores 1 y 2
         do j=1,nx
         do k=1,nz
          if(phi_w(j,k).le.phi_mean)then 
          phi_w(j,k)=phi_min
           else       
          phi_w(j,k)=phi_max
             endif
         enddo
	 enddo

c  promedio de la distribucion fractal 

	aver=0.d0
	do j=1,nx
	do k=1,nz
	aver=aver+phi_w(j,k)
	enddo
	enddo
	aver=aver/(nx*nz)
	
c   varianza 

        var = 0.d0
	do j=1,nx
	do k=1,nz
	var =var + (phi_w(j,k)-aver)**2
	enddo
	enddo 
	var = var/(nx*nz)
	ratio = dsqrt(var)/aver     	
        write(6,7841)aver,dsqrt(var),ratio
	
7841    format(/,' average of the computed fractal ', 
     1  ' field =  ',e15.5,//
     1  ' standard deviation=',e15.5,//
     1  ' ratio standard deviation/average = ',e15.5)	
	                               

c    writes  in 9  and 11 40 and 50  patches  
           s_gas= 0.d0
          do k=1,nz	 
          do j=1,nx
          write(9,97)int(phi_w(j,k))
           write(40,97)int(phi_w(j,k))
          write(50,97)int(phi_w(j,k))           
          write(11,345)j,k,int(phi_w(j,k))
345       format(i5,2x,i5,2x,i5)
          if(int(phi_w(j,k)).eq.2)then
           s_gas = s_gas+1.d0
            endif
99         format(e15.5)
97         format(i5)
          enddo
    	  enddo
          close(9)		 
	   write(6,*)' % gas saturation is (1 is sandstone, 2 is ice) ',
     1                100.d0*s_gas/(nx*nz) 
          do k=1,nz,2	 
          do j=1,nx,2
          write(20,97)int(phi_w(j,k))
995         format(e12.5)
          enddo
    	  enddo
          close(20)
	  
          do k=1,nz	 
          j=nx/2
          write(30,996)k*1.d0,phi_w(j,k)
996         format(2e12.5)
          enddo
    	 
          close(30)
  	
       return
       end
                             
*******************************************************************                                        
        subroutine fractal(sigma2,d,avk,cf) 
        include 'com_frac_wc'

        double precision a(mnx2,mnz2),spec(mnx2,mnz2),tmp(mnx2,mnz2)
     	double precision amp(mnx2,mnz2),phi(mnx2,mnz2),cf(mnx,mnz)
        double precision ran1,aver,var,var1,aver_nor
        double precision pi,twopi,xdom_r,zdom_r,sigma2,d,avk,hx,hy,
     1  fny_x,fny_y,fny,wkmax,wkmin,fminx,fminy,fmin,delfx,delfy,
     1  delwx,delwy,fj,fk,aux1,aux2,aux3,aux4,xdom,ydom
        integer j,i,k,neg,nx_2,nz_2,nx1,nx2,ny1,ny2,idum,j_ini,k_ini
        double precision cfmin,cfmax,cf_nor(mnx,mnz)

        write(6,*)' aa - neg1 in fractal = ',aa,neg1
        pi=abs(4.d0*datan(1.d0))
        twopi = 2.d0*pi

       xdom_r = x(nx+1)-x(1)
       zdom_r = z(nz+1)-z(1)
         
       hx=xdom_r/nx
       hy=zdom_r/nz

c  Se calcula un dominio expandido tal que el numero de celdas en cada
c  direccion sea de la forma 2^n, para poder utilizar la FFT y que ademas se c
c  evite la periodicidad. Se genera un dominio 2 veces mayor.

        nx_2=2
        do k=1,20
        nx_2 = nx_2*2
        if(nx_2.ge.(2*nx)) goto 212
        enddo
212     continue 
     
        nz_2 = 2
        do k=1,20
        nz_2 = nz_2*2
        if(nz_2.ge.(2*nz)) goto 213
        enddo
213     continue


        write(6,1011)nx_2,nz_2
1011    format(/' nx_2 = ',i5,' nz_2 = ',i5,/)


c
c    Calculo de las dimensiones del dominio expandido
c   
c
       xdom = xdom_r + (nx_2-nx)*hx
       ydom = zdom_r + (nz_2-nz)*hy

c       write(6,1012)xdom,ydom
c1012   format(/' xdom = ',e15.5, ' ydom = ',e15.5,/)

      
c
c     computes nyquist frequency (max. spatial frequency that can be 
c     seen with this mesh size) and minimum  spatial frequency
c

       fny_x =  1.d0/(2.d0*hx)
       fny_y =  1.d0/(2.d0*hy)

        fny = fny_x
        if(fny_y.lt.fny_x) fny = fny_y
      
       wkmax = twopi * fny 

c  Juan , new low freeq. cut using the original domain size
c     
c       fminx = 1.d0/xdom
c       fminy = 1.d0/ydom
       
       fminx = 1.d0/xdom_r
       fminy = 1.d0/zdom_r
       
        fmin = fminx
        if(fminy.gt.fminx) fmin=fminy
      
       wkmin = twopi * fmin 

       delfx= 2.d0*fny_x/nx_2
       delfy= 2.d0*fny_y/nz_2
       
       delwx = twopi*delfx
       delwy = twopi*delfy

c       write(6,1000)wkmax,wkmin,delwx,delwy
c1000   format(/,' wkmax = ',e15.5,' wkmin = ',e15.5,/,
c     1          ' delwx = ',e15.5,' delwy = ',e15.5)


c ****************************************************************
c calculo del espectro que describe un fBm. T(k).
c ****************************************************************

	nx1=nx_2/2+1
	nx2=nx_2/2+2
	ny1=nz_2/2+1
	ny2=nz_2/2+2

             	
      do j=1,nx1
      do k=1,ny1

       fj = (j-1)*delwx
       fk = (k-1)*delwy

c    fBm

c        aux1 = sigma2 * (D-3.d0)
c        aux2 = pi * ( wkmax**(2.d0*D-6.d0) - wkmin**(2.d0*D-6.d0) )
c        aux3 = dsqrt ( (fj**2 + fk**2) )
c        aux4 = aux3**(8.d0-2.d0*D) 

c   fGn  (for an fGn uncomment lines below and comment lines for
c          aux1, aux2,aux3,aux4 above)


c      aux1 = sigma2 * (D-2.d0)
c       aux2 = pi * ( wkmax**(2.d0*D-4.d0) - wkmin**(2.d0*D-4.d0) )
c       aux3 = dsqrt ( (fj**2 + fk**2) )
c       aux4 = aux3**(6.d0-2.d0*D) 

c von Karman autocovariance function. 
c  the parameter  aa   is the  correlation length
c        aa=0.06d0

 
         aux1=1.d0
         aux2=1.d0
        aux3 = 1.d0+ aa**2*(fj**2 + fk**2)
        aux5 = dsqrt(fj**2 + fk**2)
        aux4=aux3**(4.d0-d)

       if((aux5.le.wkmin).or.(aux5.ge.wkmax)) then
        spec(j,k) = 0.d0
       else    
        spec(j,k) = dsqrt ( aux1/(aux2*aux4) )
       endif
       	
      enddo
      enddo

c 1er. cuadrante

        do j=1,nx1
	i=ny1
        do k=ny2,nz_2
	i=i-1
        spec(j,k)=spec(j,i)
	enddo
        enddo


c 4er. cuadrante

        do k=1,ny1
	i=nx1
        do j=nx2,nx_2
	i=i-1
        spec(j,k)=spec(i,k)
	enddo
        enddo

c    2do. cuadrante

        do k=ny2,nz_2
	i=nx1
        do j=nx2,nx_2
	i=i-1
        spec(j,k)=spec(i,k)
	enddo
        enddo


c ******************************************************
c
c   generates white noise with uniform distribution in a(.,.)
c      
c ******************************************************

        idum=neg1 


         do k=1,nz_2-1,2
         do j=1,nx_2-1,2
 	 a(j,k) = 2.d0*ran1(idum)-1.d0
         enddo
         enddo
         do j=2,nx_2,2
         do k=2,nz_2,2
 	 a(j,k) = 2.d0*ran1(idum)-1.d0
         enddo
         enddo
         do k=1,nz_2-1,2
         do j=2,nx_2,2
 	 a(j,k) = 2.d0*ran1(idum)-1.d0
         enddo
         enddo
         do j=1,nx_2-1,2
         do k=2,nz_2,2
 	 a(j,k) = 2.d0*ran1(idum)-1.d0
         enddo
         enddo

c
c   SE imprime los numeros aleatorios
c
c          do k=1,nz
c          do j=1,nx
c          write(13,77) a(j,k)
c          enddo
c          enddo
77        format(e20.8)

c          stop 'ttt'

c **********************************************************
c LLAMAMOS A LA FFT 2D para calcular la TF del ruido blanco 
c **********************************************************

        call FFT2 (a,nx_2,nz_2,nx_2,nz_2,amp,phi,-1)

c ************************************************************
c  CALCULO DEL ESPECTRO FRACTAL
c  multiplicamos la amplitud del espectro amp(j,k) por spec(j,k) 
c  en el dominio de las frecuencias
c ************************************************************

	do j=1,nx_2
	do k=1,nz_2
	amp(j,k)=amp(j,k)*spec(j,k)
	enddo
	enddo

	 
c **********************************************************
c CALCULO DE LA ANTITRANSFORMADA
c **********************************************************

        call FFT2 (tmp,nx_2,nz_2,nx_2,nz_2,amp,phi,1)	

c **********************************************************
c RECORTE DEL DOMINIO (ZONA NO PERIODICA)
c **********************************************************

         j_ini = (nx_2-nx)/2
         k_ini = (nz_2-nz)/2

         do j=1,nx
         do k=1,nz
         cf(j,k)=tmp(j+j_ini,k+k_ini)
* campo fractal crudo
c         write(10,99)cf(j,k)
         enddo
         enddo

c **********************************************************
c NORMALIZACION DE LA COVARIANZA
c **********************************************************

c  promedio de la fluctuacion

	aver=0.d0
	do j=1,nx
	do k=1,nz
	aver=aver+cf(j,k)
	enddo
	enddo
	aver=aver/(nx*nz)

c  Se fuerza a tomar un valor cero

	do j=1,nx
	do k=1,nz
	cf(j,k)= cf(j,k)-aver
	enddo
	enddo
	aver=0.d0

c  varianza de la fluctuacion 

	var=0.d0
	do j=1,nx
	do k=1,nz
	var=var+(cf(j,k)-aver)**2.d0
	enddo
	enddo
	var=var/(nx*nz)

	do j=1,nx
	do k=1,nz
	cf(j,k) = cf(j,k)*dsqrt(sig2_ks/var)
c        write(10,99)cf(j,k)

	enddo
	enddo
c verifica que la varianza es la deseada
	var1=0.d0
	do j=1,nx
	do k=1,nz
	var1=var1+(cf(j,k)-aver)**2.d0
	enddo
	enddo
	var1=var1/(nx*nz)
        write(6,*) 'nx,nz=',nx,nz
        write(6,*) 'aver, var1=',aver,var1
        write(6,*)' actual l2_norm ',dsqrt(var1)
        write(6,*)' desired l2-norm ',dsqrt(sig2_ks)

c  forces values of cf(j,k) to be  in [-1,1]

        cfmax = cf(1,1)
        cfmin = cf(1,1)
 	do j=1,nx
	do k=1,nz
        if(cf(j,k).gt.cfmax)cfmax=cf(j,k)
        if(cf(j,k).lt.cfmin)cfmin=cf(j,k)
	enddo
	enddo

 	do j=1,nx
	do k=1,nz
        cf_nor(j,k)=(-2.d0*cf(j,k)+cfmin+cfmax)/(cfmin-cfmax)
c        write(11,99)cf_nor(j,k)
        cf(j,k)=cf_nor(j,k)
	enddo
	enddo
99       format(e15.5)

	aver_nor=0.d0
	do j=1,nx
	do k=1,nz
	aver_nor=aver_nor+ cf_nor(j,k)
	enddo
	enddo
	aver_nor=aver_nor/(nx*nz)
c  Se fuerza a tomar un valor cero

	do j=1,nx
	do k=1,nz
	cf_nor(j,k)= cf_nor(j,k)-aver_nor
	enddo
	enddo
	aver_nor=0.d0

c  varianza de la fluctuacion 

	var1=0.d0
	do j=1,nx
	do k=1,nz
	var1=var1+(cf_nor(j,k)-aver_nor)**2.d0
	enddo
	enddo
	var1=var1/(nx*nz)

        write(6,*)' actual l2_norm after [-1,1] ',dsqrt(var1)
        write(6,*)' desired l2-norm ',dsqrt(sig2_ks)

	return
        end
	
**********************************************************************  
c===============================================================
        subroutine FFT2 (xx,M,N,LFFT1,LFFT2,a,phi,isign)

c  Compute the 2-D FFT (amplitude and phase)
c  Some complex arrays are precomputed. Useful when FFT2 is called many times.

c  isign=-1 <- direct
c  IN: data(M,N): 2-D real image
c  OUT: a(LFFT1,LFFT2), phi(LFFT1,LFFT2): amplitude & phase spectra
c  
c  isign=1: inverse
c  IN: a(LFFT1,LFFT2), phi(LFFT1,LFFT2): amplitude & phase spectra
c  OUT: data(M,N): 2-D real image

c  Programmed by Danilo Velis

        include 'com_frac_wc'
        integer         m,n,lfft1,lfft2,isign,iffa,iffb,i,j
	real*8		xx(mnx2,mnz2),a(mnx2,mnz2),phi(mnx2,mnz2)
	complex*16      cw1a(mnx2),cw2a(mnz2),cw1b(mnx2),cw2b(mnz2),
     #                  c(mnx2,mnz2),c1(mnx2),c2(mnz2)
	data            iffa/0/,iffb/0/
	save

c-------DIRECT 2-D FFT
	if (isign.eq.-1) then

c----------compute FFT tables (do this only once)
   	   if (iffa.eq.0) then
c	      write (*,*) 'FFT tables...'
              call fftcw (LFFT1,cw1a,-1.d0)
              call fftcw (LFFT2,cw2a,-1.d0)
	      iffa=1
	   endif

c----------zero pad
	   do i=1,LFFT1
	      do j=1,LFFT2
		 c(i,j)=dcmplx(0.d0,0.d0)
	         if (i.le.M.and.j.le.N) c(i,j)=dcmplx(xx(i,j),0.d0)
c	         c(i,j)=dcmplx(xx(i,j),0.d0)
	      enddo
	   enddo

c----------loop thru rows
	   do i=1,LFFT1
	      do j=1,LFFT2
		 c2(j)=c(i,j)
	      enddo
	      call fft (LFFT2,c2,cw2a)
	      do j=1,LFFT2
		 c(i,j)=c2(j)
	      enddo
	   enddo

c----------loop thru columns
	   do j=1,LFFT2
	      do i=1,LFFT1
		 c1(i)=c(i,j)
	      enddo
	      call fft (LFFT1,c1,cw1a)
	      do i=1,LFFT1
		 c(i,j)=c1(i)
	      enddo
	   enddo
	      
c----------amplitude and phase
	   do i=1,LFFT1
	      do j=1,LFFT2
		 a(i,j)=cdabs(c(i,j))
		 phi(i,j)=datan2(dimag(c(i,j)),dreal(c(i,j)))
	      enddo
	   enddo
	endif

c-------INVERSE 2-D FFT
	if (isign.eq.1) then

c----------compute FFT tables (do this only once)
	   if (iffb.eq.0) then
              call fftcw (LFFT1,cw1b,1.d0)
              call fftcw (LFFT2,cw2b,1.d0)
	      iffb=1
	   endif

c----------spectrum
	   do i=1,LFFT1
	      do j=1,LFFT2
		 c(i,j)=a(i,j)*cdexp(dcmplx(0.d0,phi(i,j)))
                 xx(i,j)=0.d0
	      enddo
	   enddo

c----------loop thru rows
	   do i=1,LFFT1
	      do j=1,LFFT2
		 c2(j)=c(i,j)
	      enddo
	      call fft (LFFT2,c2,cw2b)
	      do j=1,LFFT2
		 c(i,j)=c2(j)
	      enddo
	   enddo

c----------loop thru columns
	   do j=1,LFFT2
	      do i=1,LFFT1
		 c1(i)=c(i,j)
	      enddo
	      call fft (LFFT1,c1,cw1b)
	      do i=1,LFFT1
		 c(i,j)=c1(i)
	      enddo
	   enddo

c----------object
	   do i=1,M
	      do j=1,N
		 xx(i,j)=dreal(c(i,j))
	      enddo
	   enddo
	endif

	return
	end


********************************************************************
C     _______________________________________________________
C
      SUBROUTINE FFT (N2,HC,CW)
C
C     Esta subrutina realiza la FFT del vector complejo HC
C
C     IN         HC: vector de entrada
C                N2: dimension de HC, compatible con FFT
C            CW(N2): coeficientes usados por la FFT
C                       -usar FFTCW(N2,CW,SIGN)-
C
C     OUT        HC: FFT
C     _______________________________________________________
C
       include 'com_frac_wc'
      integer n2,j,i,m,l,istep,n2l,m0
      real*8     SC
      COMPLEX*16 HC(mnn),CW(mnn),CTEMP
C
      J=1
      SC=1.d0/DSQRT(DBLE(N2))
      DO 3 I=1,N2
      IF(I.GT.J) GO TO 1
      CTEMP=HC(J)*SC
      HC(J)=HC(I)*SC
      HC(I)=CTEMP
 1    M=N2/2
 2    IF(J.LE.M) GO TO 3
      J=J-M
      M=M/2
      IF(M.GE.1) GO TO 2
 3    J=J+M
      L=1
 4    ISTEP=L+L
      N2L=N2/L
      M0=1-N2L
      DO 5 M=1,L
      M0=M0+N2L
      DO 5 I=M,N2,ISTEP
      CTEMP=CW(M0)*HC(I+L)
      HC(I+L)=HC(I)-CTEMP
 5    HC(I)=HC(I)+CTEMP
      L=ISTEP
      IF(L.LT.N2) GO TO 4
C
      RETURN
      END
C     _______________________________________________________
C
C
      SUBROUTINE FFTCW (L,CW,SIGN)
C
C     Esta subrutina calcula los coeficientes complejos CW(L)
C     requeridos por la FFT. Version D. Velis. (1991)
C
C     IN          L: dimension de CW, compatible con FFT
C              SIGN: flag: -1=FFT directa; +1=FFT inversa
C
C     OUT     CW(L): coeficientes
C
C
C
       include 'com_frac_wc'
      real*8     PI,SIGN
      COMPLEX*16 CW(mnn)
      integer l,m
C
      PI=4.d0*DATAN(1.d0)
      DO 10 M=1,L
 10   CW(M)=CDEXP((0.d0,1.d0)*(PI*(M-1)*SIGN)/L)
C
      RETURN
      END
C
*************************************************************************

      FUNCTION ran1(idum)
      INTEGER idum,IA,IM,IQ,IR,NTAB,NDIV
      REAL*8 ran1,AM,EPS,RNMX
      PARAMETER (IA=16807,IM=2147483647,AM=1./IM,IQ=127773,IR=2836,
c     *NTAB=32,NDIV=1+(IM-1)/NTAB,EPS=1.2e-7,RNMX=1.-EPS)
     *NTAB=32,NDIV=1+(IM-1)/NTAB,EPS=1.2d-12,RNMX=1.d0-EPS)     
      INTEGER j,k,iv(NTAB),iy
      SAVE iv,iy
      DATA iv /NTAB*0/, iy /0/
      if (idum.le.0.or.iy.eq.0) then
        idum=max(-idum,1)
        do 11 j=NTAB+8,1,-1
          k=idum/IQ
          idum=IA*(idum-k*IQ)-IR*k
          if (idum.lt.0) idum=idum+IM
          if (j.le.NTAB) iv(j)=idum
11      continue
        iy=iv(1)
      endif
      k=idum/IQ
      idum=IA*(idum-k*IQ)-IR*k
      if (idum.lt.0) idum=idum+IM
      j=1+iy/NDIV
      iy=iv(j)
      iv(j)=idum
      ran1=min(AM*iy,RNMX)
      return
      END
